require 'studiogame/player'
require 'studiogame/berserk_player'
require 'studiogame/spechelper'

module StudioGame
  describe BerserkPlayer do

    before do
      $stdout = StringIO.new
      @initial_health = 50
      @player = BerserkPlayer.new("berserker", @initial_health)
    end

    it "does not go berserk when healthpacked up to 5 times" do
      1.upto(5) {@player.healthpack}
      @player.berserk?.should be_falsey
    end

    it "goes berserk when healthpacked more than 5 times" do
      1.upto(6) {@player.healthpack}
      @player.berserk?.should be_truthy
    end

    it "gets healthpacked instead of blammed when it's gone berserk" do
      1.upto(6) {@player.healthpack}
      1.upto(2) {@player.hit}
      @player.health.should == @initial_health + (8*10)
    end

  end
end
