require 'studiogame/game'
require 'studiogame/spechelper'

module StudioGame
  describe Game do
    before do
        $stdout = StringIO.new
      @game=Game.new("lol")
      @initial_health=100
      @player= Player.new("moe", @initial_health)
      @game.addplayer(@player)
    end
      it "has a title" do
        @game.title.should == "Lol"
      end
      it "gives the player a healthpack if a high number is rolled" do
        allow_any_instance_of(Die).to receive(:roll).and_return(5)
        @game.play (2)
        @player.health.should == @initial_health + (10*2)
      end

      it "skips the player if a medium number is number is rolled" do
      allow_any_instance_of(Die).to receive(:roll).and_return(3)
        @game.play(2)
        @player.health.should == @initial_health
      end
      it "gives the player a hit if a low number is rolled" do
        allow_any_instance_of(Die).to receive(:roll).and_return(1)
        @game.play(2)
        @player.health.should == @initial_health - (10*2)
      end

      it "assigns a treasure for points during a player's turn" do
        game = Game.new("Knuckleheads")
        player=Player.new("moe")

        game.addplayer(player)

        game.play(1)
        player.points.should_not be_zero
      end
  end
end
